require 'omniauth-oauth2'


module OmniAuth
  module Strategies
    class Sanderling < OmniAuth::Strategies::OAuth2
      option :name, :sanderling
      
      option :client_options, { site: "https://sanderling.io",
                                authorize_path: "/oauth/authorize",
                              }
      
      
      
      uid { raw_info['id'].to_s }
      
      info do
        {
          name: raw_info['username'],
          first_name: raw_info['first_name'],
          last_name: raw_info['last_name'],
          email: raw_info['email'],
          avatar_image_url: raw_info['avatar_image_url'],
          urls: {
            'Sanderling' => "https://sanderling.io/#{raw_info['username']}"
          }
        }
      end
      
      extra do
        { raw_info: raw_info }
      end
      
      def raw_info
        @raw_info ||= access_token.get('/api/v1/me.json').parsed
      end
      
    end
  end
end
